A single cell can be used to represent multiple contiguous leaf rows with equal values.
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColumnApiModule,
GridApi,
GridOptions,
ModuleRegistry,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
CellSpanModule,
ClientSideRowModelModule,
ColumnApiModule,
]);
const columnDefs: ColDef[] = [
{ field: "country", spanRows: true, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: columnDefs,
defaultColDef: {
flex: 1,
},
enableCellSpan: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Enabling Row Spanning Copy Link
The example above demonstrates merging cells with equal values into a single cell that spans multiple rows.
Row spanning requires the CellSpanModule to be registered. The enableCellSpan grid option is an initial property and cannot be changed after the grid is created.
The following snippet demonstrates enabling row spanning by setting gridOptions.enableCellSpan to true. The country, year, and sport columns then configure row span by setting colDef.spanRows to true.
const gridOptions = {
columnDefs: [
{
field: 'country',
spanRows: true,
},
{
field: 'year',
spanRows: true,
},
{
field: 'sport',
spanRows: true,
},
// other column definitions ...
],
enableCellSpan: true,
// other grid options ...
} Custom Row Spanning Copy Link
Row spanning can be customised by providing a callback function to colDef.spanRows. The callback returns true if the two adjacent rows should be spanned together.
The example below demonstrates custom row spanning which prevents any country cells with the value "Algeria" from being spanned.
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
SpanRowsParams,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([CellSpanModule, ClientSideRowModelModule]);
const customSpanFunc = ({ valueA, valueB }: SpanRowsParams) => {
return valueA != "Algeria" && valueA === valueB;
};
const columnDefs: ColDef[] = [
{ field: "country", spanRows: customSpanFunc, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: columnDefs,
defaultColDef: {
flex: 1,
},
enableCellSpan: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: IOlympicData[]) => gridApi!.setGridOption("rowData", data));
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The following snippet demonstrates how to configure custom row spanning on the country column:
const gridOptions = {
columnDefs: [
{
field: 'country',
spanRows: ({ valueA, valueB }) => valueA != 'Algeria' && valueA === valueB,
},
// other column definitions ...
],
enableCellSpan: true,
// other grid options ...
} Auto Height and Row Spanning Copy Link
Row spanning can be configured alongside auto height. Note when doing so, if the cell is taller than the combined height of the rows, the last row in the span gains any additional required height.
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
GridApi,
GridOptions,
ModuleRegistry,
RowAutoHeightModule,
createGrid,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
// Enable extended validations only for development
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
CellSpanModule,
ClientSideRowModelModule,
RowAutoHeightModule,
]);
const lorem = `Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.`;
const columnDefs: ColDef[] = [
{
field: "lorem",
spanRows: true,
wrapText: true,
autoHeight: true,
minWidth: 300,
},
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
];
let gridApi: GridApi<IOlympicData>;
const gridOptions: GridOptions<IOlympicData> = {
columnDefs: columnDefs,
defaultColDef: {
flex: 1,
},
enableCellSpan: true,
};
const gridDiv = document.querySelector<HTMLElement>("#myGrid")!;
gridApi = createGrid(gridDiv, gridOptions);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((response) => response.json())
.then((data: any[]) => {
data.forEach((row, i) => {
if (i % 3 === 0) {
return;
}
row.lorem = lorem;
});
gridApi!.setGridOption("rowData", data);
});
<div id="myGrid" style="height: 100%"></div>
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The following snippet demonstrates how to configure auto height and row spanning:
const gridOptions = {
columnDefs: [
{
field: 'lorem',
spanRows: true,
autoHeight: true,
wrapText: true,
},
// other column definitions ...
],
enableCellSpan: true,
// other grid options ...
}

A single cell can be used to represent multiple contiguous leaf rows with equal values.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
CellSpanModule,
ClientSideRowModelModule,
ColumnApiModule,
]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:enableCellSpan="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", spanRows: true, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Enabling Row Spanning Copy Link
The example above demonstrates merging cells with equal values into a single cell that spans multiple rows.
Row spanning requires the CellSpanModule to be registered. The enableCellSpan grid option is an initial property and cannot be changed after the grid is created.
The following snippet demonstrates enabling row spanning by setting gridOptions.enableCellSpan to true. The country, year, and sport columns then configure row span by setting colDef.spanRows to true.
<ag-grid-vue
:columnDefs="columnDefs"
:enableCellSpan="enableCellSpan"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'country',
spanRows: true,
},
{
field: 'year',
spanRows: true,
},
{
field: 'sport',
spanRows: true,
},
// other column definitions ...
];
this.enableCellSpan = true; Custom Row Spanning Copy Link
Row spanning can be customised by providing a callback function to colDef.spanRows. The callback returns true if the two adjacent rows should be spanned together.
The example below demonstrates custom row spanning which prevents any country cells with the value "Algeria" from being spanned.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
SpanRowsParams,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([CellSpanModule, ClientSideRowModelModule]);
const customSpanFunc = ({ valueA, valueB }: SpanRowsParams) => {
return valueA != "Algeria" && valueA === valueB;
};
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:enableCellSpan="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{ field: "country", spanRows: customSpanFunc, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The following snippet demonstrates how to configure custom row spanning on the country column:
<ag-grid-vue
:columnDefs="columnDefs"
:enableCellSpan="enableCellSpan"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'country',
spanRows: ({ valueA, valueB }) => valueA != 'Algeria' && valueA === valueB,
},
// other column definitions ...
];
this.enableCellSpan = true; Auto Height and Row Spanning Copy Link
Row spanning can be configured alongside auto height. Note when doing so, if the cell is taller than the combined height of the rows, the last row in the span gains any additional required height.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowAutoHeightModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
CellSpanModule,
ClientSideRowModelModule,
RowAutoHeightModule,
]);
const lorem = `Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.`;
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:enableCellSpan="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<ColDef[]>([
{
field: "lorem",
spanRows: true,
wrapText: true,
autoHeight: true,
minWidth: 300,
},
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => {
data.forEach((row, i) => {
if (i % 3 === 0) {
return;
}
row.lorem = lorem;
});
rowData.value = data;
};
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
The following snippet demonstrates how to configure auto height and row spanning:
<ag-grid-vue
:columnDefs="columnDefs"
:enableCellSpan="enableCellSpan"
/* other grid options ... */>
</ag-grid-vue>
this.columnDefs = [
{
field: 'lorem',
spanRows: true,
autoHeight: true,
wrapText: true,
},
// other column definitions ...
];
this.enableCellSpan = true;

A single cell can be used to represent multiple contiguous leaf rows with equal values.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [CellSpanModule, ClientSideRowModelModule, ColumnApiModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", spanRows: true, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
enableCellSpan={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; Enabling Row Spanning Copy Link
The example above demonstrates merging cells with equal values into a single cell that spans multiple rows.
Row spanning requires the CellSpanModule to be registered. The enableCellSpan grid option is an initial property and cannot be changed after the grid is created.
The following snippet demonstrates enabling row spanning by setting gridOptions.enableCellSpan to true. The country, year, and sport columns then configure row span by setting colDef.spanRows to true.
const [columnDefs, setColumnDefs] = useState([
{
field: 'country',
spanRows: true,
},
{
field: 'year',
spanRows: true,
},
{
field: 'sport',
spanRows: true,
},
// other column definitions ...
]);
const enableCellSpan = true;
<AgGridReact
columnDefs={columnDefs}
enableCellSpan={enableCellSpan}
/> Custom Row Spanning Copy Link
Row spanning can be customised by providing a callback function to colDef.spanRows. The callback returns true if the two adjacent rows should be spanned together.
The example below demonstrates custom row spanning which prevents any country cells with the value "Algeria" from being spanned.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
SpanRowsParams,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [CellSpanModule, ClientSideRowModelModule];
const customSpanFunc = ({ valueA, valueB }: SpanRowsParams) => {
return valueA != "Algeria" && valueA === valueB;
};
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ field: "country", spanRows: customSpanFunc, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
enableCellSpan={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
setData(data);
setLoading(false);
};
fetchData();
}, [url, limit]);
return { data, loading };
}; The following snippet demonstrates how to configure custom row spanning on the country column:
const [columnDefs, setColumnDefs] = useState([
{
field: 'country',
spanRows: ({ valueA, valueB }) => valueA != 'Algeria' && valueA === valueB,
},
// other column definitions ...
]);
const enableCellSpan = true;
<AgGridReact
columnDefs={columnDefs}
enableCellSpan={enableCellSpan}
/> Auto Height and Row Spanning Copy Link
Row spanning can be configured alongside auto height. Note when doing so, if the cell is taller than the combined height of the rows, the last row in the span gains any additional required height.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowAutoHeightModule,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
const modules = [CellSpanModule, ClientSideRowModelModule, RowAutoHeightModule];
const lorem = `Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.`;
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<IOlympicData[]>();
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{
field: "lorem",
spanRows: true,
wrapText: true,
autoHeight: true,
minWidth: 300,
},
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const onGridReady = useCallback((params: GridReadyEvent) => {
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data: IOlympicData[]) => {
data.forEach((row, i) => {
if (i % 3 === 0) {
return;
}
row.lorem = lorem;
});
setRowData(data);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={rowData}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
enableCellSpan={true}
onGridReady={onGridReady}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The following snippet demonstrates how to configure auto height and row spanning:
const [columnDefs, setColumnDefs] = useState([
{
field: 'lorem',
spanRows: true,
autoHeight: true,
wrapText: true,
},
// other column definitions ...
]);
const enableCellSpan = true;
<AgGridReact
columnDefs={columnDefs}
enableCellSpan={enableCellSpan}
/>

A single cell can be used to represent multiple contiguous leaf rows with equal values.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnApiModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
CellSpanModule,
ClientSideRowModelModule,
ColumnApiModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[enableCellSpan]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", spanRows: true, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Enabling Row Spanning Copy Link
The example above demonstrates merging cells with equal values into a single cell that spans multiple rows.
Row spanning requires the CellSpanModule to be registered. The enableCellSpan grid option is an initial property and cannot be changed after the grid is created.
The following snippet demonstrates enabling row spanning by setting gridOptions.enableCellSpan to true. The country, year, and sport columns then configure row span by setting colDef.spanRows to true.
<ag-grid-angular
[columnDefs]="columnDefs"
[enableCellSpan]="enableCellSpan"
/* other grid options ... */ />
this.columnDefs = [
{
field: 'country',
spanRows: true,
},
{
field: 'year',
spanRows: true,
},
{
field: 'sport',
spanRows: true,
},
// other column definitions ...
];
this.enableCellSpan = true; Custom Row Spanning Copy Link
Row spanning can be customised by providing a callback function to colDef.spanRows. The callback returns true if the two adjacent rows should be spanned together.
The example below demonstrates custom row spanning which prevents any country cells with the value "Algeria" from being spanned.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
SpanRowsParams,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([CellSpanModule, ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[enableCellSpan]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{ field: "country", spanRows: customSpanFunc, sort: "asc" },
{ field: "year", spanRows: true, sort: "asc" },
{ field: "sport", spanRows: true, sort: "asc" },
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
const customSpanFunc = ({ valueA, valueB }: SpanRowsParams) => {
return valueA != "Algeria" && valueA === valueB;
};
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The following snippet demonstrates how to configure custom row spanning on the country column:
<ag-grid-angular
[columnDefs]="columnDefs"
[enableCellSpan]="enableCellSpan"
/* other grid options ... */ />
this.columnDefs = [
{
field: 'country',
spanRows: ({ valueA, valueB }) => valueA != 'Algeria' && valueA === valueB,
},
// other column definitions ...
];
this.enableCellSpan = true; Auto Height and Row Spanning Copy Link
Row spanning can be configured alongside auto height. Note when doing so, if the cell is taller than the combined height of the rows, the last row in the span gains any additional required height.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
CellSpanModule,
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
RowAutoHeightModule,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
enableDevValidations();
}
ModuleRegistry.registerModules([
CellSpanModule,
ClientSideRowModelModule,
RowAutoHeightModule,
]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[enableCellSpan]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: ColDef[] = [
{
field: "lorem",
spanRows: true,
wrapText: true,
autoHeight: true,
minWidth: 300,
},
{ field: "athlete" },
{ field: "age" },
{ field: "total" },
];
defaultColDef: ColDef = {
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => {
data.forEach((row, i) => {
if (i % 3 === 0) {
return;
}
row.lorem = lorem;
});
this.rowData = data;
});
}
}
const lorem = `Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.`;
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} The following snippet demonstrates how to configure auto height and row spanning:
<ag-grid-angular
[columnDefs]="columnDefs"
[enableCellSpan]="enableCellSpan"
/* other grid options ... */ />
this.columnDefs = [
{
field: 'lorem',
spanRows: true,
autoHeight: true,
wrapText: true,
},
// other column definitions ...
];
this.enableCellSpan = true;